/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingClient;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;


import jtrackingbusiness.ReceptionFacadeEJB;
import jtrackingbusiness.ReceptionFacadeEJBService;

/**
 * The Class Main.
 */
public class Main {
	
	/**
	 * The main method.
	 *
	 * @param args the arguments
	 */
	public static void main(String[] args) {
		
		try {
			StringBuilder sb = new StringBuilder();
			sb.append("*******************************************************************\n");
			sb.append("*Programa para la simulación de dispositivos de control de flotas.*\n");
			sb.append("*      El programa simula el envío de información.                *\n");
			sb.append("*           Dispositivo simulado:                                 *\n");
			sb.append("*           Modelo: Jradia01                                      *\n");
			sb.append("*           Número de serie 001                                   *\n");
			sb.append("*******************************************************************\n");
			sb.append("\n\n");
			
			System.out.println(sb.toString());
			System.out.println("\n\n");
		
		ReceptionFacadeEJBService rfs = new ReceptionFacadeEJBService();
		ReceptionFacadeEJB port = rfs.getReceptionFacadeEJBPort();
		
		
				
			System.out.println("Jradia-01-1245 status: Gsm active, GSM sending, GPS active, GPS awake");
			System.out.println(port.receiveStatus("Jradia-01-1245 status: Gsm active, GSM sending, GPS active, GPS awake"));
			Thread.sleep(5000);
			System.out.println("Jradia-01-1234 battery:  aaa mV");
			System.out.println(port.receiveBatteryLevel("Jradia-01-1234 battery:  aaa mV"));
			Thread.sleep(5000);
			System.out.println("Jradia-01-1234 GSM signal strength: -100 dbm");
			System.out.println(port.receiveGsmSignal("Jradia-01-1234 GSM signal strength: -100 dbm"));
			Thread.sleep(5000);
			System.out.println("\n\n");
			System.out.println("Obteniendo comandos de configuración para el dispositivo Jradia-01 S/N 001");
			System.out.println(port.obtainConfiguration("Jradia-01-001"));
			Thread.sleep(5000);
			System.out.println("Enviando información de estado");
			System.out.println("Jradia-01-001 status: Gsm active, GSM sending, GPS active, GPS awake");
			System.out.println(port.receiveStatus("Jradia-01-001 status: Gsm active, GSM sending, GPS active, GPS awake"));
			Thread.sleep(5000);
			System.out.println("Jradia-01-001 battery:  4122 mV");
			System.out.println(port.receiveBatteryLevel("Jradia-01-001 battery:  4122 mV"));
			Thread.sleep(5000);
			System.out.println("Jradia-01-001 GSM signal strength: -73 dbm");
			System.out.println(port.receiveGsmSignal("Jradia-01-001 GSM signal strength: -73 dbm"));
			System.out.println("\n\n");		
			
			System.out.println("Enviando posiciones desde fichero");
			
			List<String> positions = Files.readAllLines(Paths.get("track8.csv"));
			System.out.println(Paths.get("track8.csv"));
			for(String pos: positions){
				System.out.println(pos);
				System.out.println(port.receivePosition(pos));
				Thread.sleep(5000);
			}
			
			
		} catch (Exception e) {
			System.out.println("Problemas en el servidor..." + "\n");
			
		}
		finally {
			System.out.println("Programa finalizado\n");
		}
		
	}

	/**
	 * Instantiates a new main.
	 */
	/* (non-Java-doc)
	 * @see java.lang.Object#Object()
	 */
	public Main() {
		super();
	}

}