/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */

package jtrackingbusiness;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.namespace.QName;


/**
 * A factory for creating Object objects.
 */
@XmlRegistry
public class ObjectFactory {

    /** The Constant _ReceiveStatus_QNAME. */
    private final static QName _ReceiveStatus_QNAME = new QName("http://jtrackingBusiness/", "receiveStatus");
    
    /** The Constant _ReceiveStatusResponse_QNAME. */
    private final static QName _ReceiveStatusResponse_QNAME = new QName("http://jtrackingBusiness/", "receiveStatusResponse");
    
    /** The Constant _ReceivePositionResponse_QNAME. */
    private final static QName _ReceivePositionResponse_QNAME = new QName("http://jtrackingBusiness/", "receivePositionResponse");
    
    /** The Constant _ReceiveBatteryLevel_QNAME. */
    private final static QName _ReceiveBatteryLevel_QNAME = new QName("http://jtrackingBusiness/", "receiveBatteryLevel");
    
    /** The Constant _ReceiveBatteryLevelResponse_QNAME. */
    private final static QName _ReceiveBatteryLevelResponse_QNAME = new QName("http://jtrackingBusiness/", "receiveBatteryLevelResponse");
    
    /** The Constant _ObtainConfiguration_QNAME. */
    private final static QName _ObtainConfiguration_QNAME = new QName("http://jtrackingBusiness/", "obtainConfiguration");
    
    /** The Constant _ReceiveGsmSignalResponse_QNAME. */
    private final static QName _ReceiveGsmSignalResponse_QNAME = new QName("http://jtrackingBusiness/", "receiveGsmSignalResponse");
    
    /** The Constant _ObtainConfigurationResponse_QNAME. */
    private final static QName _ObtainConfigurationResponse_QNAME = new QName("http://jtrackingBusiness/", "obtainConfigurationResponse");
    
    /** The Constant _ReceivePosition_QNAME. */
    private final static QName _ReceivePosition_QNAME = new QName("http://jtrackingBusiness/", "receivePosition");
    
    /** The Constant _ReceiveGsmSignal_QNAME. */
    private final static QName _ReceiveGsmSignal_QNAME = new QName("http://jtrackingBusiness/", "receiveGsmSignal");

    /**
     * Instantiates a new object factory.
     */
    public ObjectFactory() {
    }

    /**
     * Creates a new Object object.
     *
     * @return the receive battery level
     */
    public ReceiveBatteryLevel createReceiveBatteryLevel() {
        return new ReceiveBatteryLevel();
    }

    /**
     * Creates a new Object object.
     *
     * @return the receive battery level response
     */
    public ReceiveBatteryLevelResponse createReceiveBatteryLevelResponse() {
        return new ReceiveBatteryLevelResponse();
    }

    /**
     * Creates a new Object object.
     *
     * @return the receive gsm signal response
     */
    public ReceiveGsmSignalResponse createReceiveGsmSignalResponse() {
        return new ReceiveGsmSignalResponse();
    }

    /**
     * Creates a new Object object.
     *
     * @return the obtain configuration
     */
    public ObtainConfiguration createObtainConfiguration() {
        return new ObtainConfiguration();
    }

    /**
     * Creates a new Object object.
     *
     * @return the receive gsm signal
     */
    public ReceiveGsmSignal createReceiveGsmSignal() {
        return new ReceiveGsmSignal();
    }

    /**
     * Creates a new Object object.
     *
     * @return the obtain configuration response
     */
    public ObtainConfigurationResponse createObtainConfigurationResponse() {
        return new ObtainConfigurationResponse();
    }

    /**
     * Creates a new Object object.
     *
     * @return the receive position
     */
    public ReceivePosition createReceivePosition() {
        return new ReceivePosition();
    }

    /**
     * Creates a new Object object.
     *
     * @return the receive status
     */
    public ReceiveStatus createReceiveStatus() {
        return new ReceiveStatus();
    }

    /**
     * Creates a new Object object.
     *
     * @return the receive status response
     */
    public ReceiveStatusResponse createReceiveStatusResponse() {
        return new ReceiveStatusResponse();
    }

    /**
     * Creates a new Object object.
     *
     * @return the receive position response
     */
    public ReceivePositionResponse createReceivePositionResponse() {
        return new ReceivePositionResponse();
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< receive status>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "receiveStatus")
    public JAXBElement<ReceiveStatus> createReceiveStatus(ReceiveStatus value) {
        return new JAXBElement<ReceiveStatus>(_ReceiveStatus_QNAME, ReceiveStatus.class, null, value);
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< receive status response>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "receiveStatusResponse")
    public JAXBElement<ReceiveStatusResponse> createReceiveStatusResponse(ReceiveStatusResponse value) {
        return new JAXBElement<ReceiveStatusResponse>(_ReceiveStatusResponse_QNAME, ReceiveStatusResponse.class, null, value);
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< receive position response>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "receivePositionResponse")
    public JAXBElement<ReceivePositionResponse> createReceivePositionResponse(ReceivePositionResponse value) {
        return new JAXBElement<ReceivePositionResponse>(_ReceivePositionResponse_QNAME, ReceivePositionResponse.class, null, value);
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< receive battery level>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "receiveBatteryLevel")
    public JAXBElement<ReceiveBatteryLevel> createReceiveBatteryLevel(ReceiveBatteryLevel value) {
        return new JAXBElement<ReceiveBatteryLevel>(_ReceiveBatteryLevel_QNAME, ReceiveBatteryLevel.class, null, value);
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< receive battery level response>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "receiveBatteryLevelResponse")
    public JAXBElement<ReceiveBatteryLevelResponse> createReceiveBatteryLevelResponse(ReceiveBatteryLevelResponse value) {
        return new JAXBElement<ReceiveBatteryLevelResponse>(_ReceiveBatteryLevelResponse_QNAME, ReceiveBatteryLevelResponse.class, null, value);
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< obtain configuration>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "obtainConfiguration")
    public JAXBElement<ObtainConfiguration> createObtainConfiguration(ObtainConfiguration value) {
        return new JAXBElement<ObtainConfiguration>(_ObtainConfiguration_QNAME, ObtainConfiguration.class, null, value);
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< receive gsm signal response>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "receiveGsmSignalResponse")
    public JAXBElement<ReceiveGsmSignalResponse> createReceiveGsmSignalResponse(ReceiveGsmSignalResponse value) {
        return new JAXBElement<ReceiveGsmSignalResponse>(_ReceiveGsmSignalResponse_QNAME, ReceiveGsmSignalResponse.class, null, value);
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< obtain configuration response>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "obtainConfigurationResponse")
    public JAXBElement<ObtainConfigurationResponse> createObtainConfigurationResponse(ObtainConfigurationResponse value) {
        return new JAXBElement<ObtainConfigurationResponse>(_ObtainConfigurationResponse_QNAME, ObtainConfigurationResponse.class, null, value);
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< receive position>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "receivePosition")
    public JAXBElement<ReceivePosition> createReceivePosition(ReceivePosition value) {
        return new JAXBElement<ReceivePosition>(_ReceivePosition_QNAME, ReceivePosition.class, null, value);
    }

    /**
     * Creates a new Object object.
     *
     * @param value the value
     * @return the JAXB element< receive gsm signal>
     */
    @XmlElementDecl(namespace = "http://jtrackingBusiness/", name = "receiveGsmSignal")
    public JAXBElement<ReceiveGsmSignal> createReceiveGsmSignal(ReceiveGsmSignal value) {
        return new JAXBElement<ReceiveGsmSignal>(_ReceiveGsmSignal_QNAME, ReceiveGsmSignal.class, null, value);
    }

}
