/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */

package jtrackingbusiness;

import java.util.List;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;


/**
 * The Interface ReceptionFacadeEJB.
 */
@WebService(name = "ReceptionFacadeEJB", targetNamespace = "http://jtrackingBusiness/")
@XmlSeeAlso({
    ObjectFactory.class
})
public interface ReceptionFacadeEJB {


    /**
     * Receive battery level.
     *
     * @param arg0 the arg 0
     * @return true, if successful
     */
    @WebMethod
    @WebResult(targetNamespace = "")
    @RequestWrapper(localName = "receiveBatteryLevel", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ReceiveBatteryLevel")
    @ResponseWrapper(localName = "receiveBatteryLevelResponse", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ReceiveBatteryLevelResponse")
    public boolean receiveBatteryLevel(
        @WebParam(name = "arg0", targetNamespace = "")
        String arg0);

    /**
     * Receive status.
     *
     * @param arg0 the arg 0
     * @return true, if successful
     */
    @WebMethod
    @WebResult(targetNamespace = "")
    @RequestWrapper(localName = "receiveStatus", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ReceiveStatus")
    @ResponseWrapper(localName = "receiveStatusResponse", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ReceiveStatusResponse")
    public boolean receiveStatus(
        @WebParam(name = "arg0", targetNamespace = "")
        String arg0);

    /**
     * Obtain configuration.
     *
     * @param arg0 the arg 0
     * @return the list
     */
    @WebMethod
    @WebResult(targetNamespace = "")
    @RequestWrapper(localName = "obtainConfiguration", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ObtainConfiguration")
    @ResponseWrapper(localName = "obtainConfigurationResponse", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ObtainConfigurationResponse")
    public List<String> obtainConfiguration(
        @WebParam(name = "arg0", targetNamespace = "")
        String arg0);

    /**
     * Receive position.
     *
     * @param arg0 the arg 0
     * @return true, if successful
     */
    @WebMethod
    @WebResult(targetNamespace = "")
    @RequestWrapper(localName = "receivePosition", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ReceivePosition")
    @ResponseWrapper(localName = "receivePositionResponse", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ReceivePositionResponse")
    public boolean receivePosition(
        @WebParam(name = "arg0", targetNamespace = "")
        String arg0);

    /**
     * Receive gsm signal.
     *
     * @param arg0 the arg 0
     * @return true, if successful
     */
    @WebMethod
    @WebResult(targetNamespace = "")
    @RequestWrapper(localName = "receiveGsmSignal", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ReceiveGsmSignal")
    @ResponseWrapper(localName = "receiveGsmSignalResponse", targetNamespace = "http://jtrackingBusiness/", className = "jtrackingbusiness.ReceiveGsmSignalResponse")
    public boolean receiveGsmSignal(
        @WebParam(name = "arg0", targetNamespace = "")
        String arg0);

}
