/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */

package jtrackingbusiness;

import java.net.MalformedURLException;
import java.net.URL;
import javax.xml.namespace.QName;
import javax.xml.ws.Service;
import javax.xml.ws.WebEndpoint;
import javax.xml.ws.WebServiceClient;
import javax.xml.ws.WebServiceException;
import javax.xml.ws.WebServiceFeature;


/**
 * The Class ReceptionFacadeEJBService.
 */
@WebServiceClient(name = "ReceptionFacadeEJBService", targetNamespace = "http://jtrackingBusiness/", wsdlLocation = "http://localhost:8080/J-trackingEJB/ReceptionFacadeEJB?wsdl")
public class ReceptionFacadeEJBService
    extends Service
{

    /** The Constant RECEPTIONFACADEEJBSERVICE_WSDL_LOCATION. */
    private final static URL RECEPTIONFACADEEJBSERVICE_WSDL_LOCATION;
    
    /** The Constant RECEPTIONFACADEEJBSERVICE_EXCEPTION. */
    private final static WebServiceException RECEPTIONFACADEEJBSERVICE_EXCEPTION;
    
    /** The Constant RECEPTIONFACADEEJBSERVICE_QNAME. */
    private final static QName RECEPTIONFACADEEJBSERVICE_QNAME = new QName("http://jtrackingBusiness/", "ReceptionFacadeEJBService");

    static {
        URL url = null;
        WebServiceException e = null;
        try {
            url = new URL("http://localhost:8080/J-trackingEJB/ReceptionFacadeEJB?wsdl");
        } catch (MalformedURLException ex) {
            e = new WebServiceException(ex);
        }
        RECEPTIONFACADEEJBSERVICE_WSDL_LOCATION = url;
        RECEPTIONFACADEEJBSERVICE_EXCEPTION = e;
    }

    /**
     * Instantiates a new reception facade EJB service.
     */
    public ReceptionFacadeEJBService() {
        super(__getWsdlLocation(), RECEPTIONFACADEEJBSERVICE_QNAME);
    }

    /**
     * Instantiates a new reception facade EJB service.
     *
     * @param features the features
     */
    public ReceptionFacadeEJBService(WebServiceFeature... features) {
        super(__getWsdlLocation(), RECEPTIONFACADEEJBSERVICE_QNAME, features);
    }

    /**
     * Instantiates a new reception facade EJB service.
     *
     * @param wsdlLocation the wsdl location
     */
    public ReceptionFacadeEJBService(URL wsdlLocation) {
        super(wsdlLocation, RECEPTIONFACADEEJBSERVICE_QNAME);
    }

    /**
     * Instantiates a new reception facade EJB service.
     *
     * @param wsdlLocation the wsdl location
     * @param features the features
     */
    public ReceptionFacadeEJBService(URL wsdlLocation, WebServiceFeature... features) {
        super(wsdlLocation, RECEPTIONFACADEEJBSERVICE_QNAME, features);
    }

    /**
     * Instantiates a new reception facade EJB service.
     *
     * @param wsdlLocation the wsdl location
     * @param serviceName the service name
     */
    public ReceptionFacadeEJBService(URL wsdlLocation, QName serviceName) {
        super(wsdlLocation, serviceName);
    }

    /**
     * Instantiates a new reception facade EJB service.
     *
     * @param wsdlLocation the wsdl location
     * @param serviceName the service name
     * @param features the features
     */
    public ReceptionFacadeEJBService(URL wsdlLocation, QName serviceName, WebServiceFeature... features) {
        super(wsdlLocation, serviceName, features);
    }

    /**
     * Gets the reception facade EJB port.
     *
     * @return the reception facade EJB port
     */
    @WebEndpoint(name = "ReceptionFacadeEJBPort")
    public ReceptionFacadeEJB getReceptionFacadeEJBPort() {
        return super.getPort(new QName("http://jtrackingBusiness/", "ReceptionFacadeEJBPort"), ReceptionFacadeEJB.class);
    }

    /**
     * Gets the reception facade EJB port.
     *
     * @param features the features
     * @return the reception facade EJB port
     */
    @WebEndpoint(name = "ReceptionFacadeEJBPort")
    public ReceptionFacadeEJB getReceptionFacadeEJBPort(WebServiceFeature... features) {
        return super.getPort(new QName("http://jtrackingBusiness/", "ReceptionFacadeEJBPort"), ReceptionFacadeEJB.class, features);
    }

    /**
     * Gets the wsdl location.
     *
     * @return the url
     */
    private static URL __getWsdlLocation() {
        if (RECEPTIONFACADEEJBSERVICE_EXCEPTION!= null) {
            throw RECEPTIONFACADEEJBSERVICE_EXCEPTION;
        }
        return RECEPTIONFACADEEJBSERVICE_WSDL_LOCATION;
    }

}
