/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingBusiness;

import java.util.Collection;

import javax.ejb.Local;

import jtrackingPersistence.CommandJPA;
import jtrackingPersistence.DeviceJPA;

/**
 * The Interface ICommandBusiness.
 */
@Local
public interface ICommandBusiness {
	
	/**
	 * Start send positions.
	 *
	 * @param deviceId the device id
	 * @return the boolean
	 * @throws Exception the exception
	 */
	public Boolean	startSendPositions(Integer deviceId) throws Exception;
	
	/**
	 * Stop send positions.
	 *
	 * @param deviceId the device id
	 * @return the boolean
	 * @throws Exception the exception
	 */
	public Boolean	stopSendPositions(Integer deviceId) throws Exception;
	
	/**
	 * Request battey level.
	 *
	 * @param deviceId the device id
	 * @return the boolean
	 * @throws Exception the exception
	 */
	public Boolean	requestBatteyLevel(Integer deviceId) throws Exception;
	
	/**
	 * Request gsm signal.
	 *
	 * @param deviceId the device id
	 * @return the boolean
	 * @throws Exception the exception
	 */
	public Boolean	requestGsmSignal(Integer deviceId) throws Exception;
	
	/**
	 * List commands.
	 *
	 * @return the collection
	 * @throws Exception the exception
	 */
	public Collection<CommandJPA> listCommands() throws Exception;
	
	/**
	 * Delete command.
	 *
	 * @param id the id
	 * @return the boolean
	 * @throws Exception the exception
	 */
	public Boolean deleteCommand(Integer id) throws Exception;
	
	/**
	 * Check status.
	 *
	 * @return the collection
	 * @throws Exception the exception
	 */
	public Collection<DeviceJPA> checkStatus() throws Exception;
	
	/**
	 * Request status.
	 *
	 * @param deviceId the device id
	 * @return the boolean
	 * @throws Exception the exception
	 */
	public Boolean requestStatus(Integer deviceId) throws Exception;
	

}
