/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingBusiness;

import java.util.Collection;
import java.util.Date;
import javax.ejb.Local;

import jtrackingPersistence.PositionJPA;

/**
 * The Interface IMappingBusiness.
 */
@Local
public interface IMappingBusiness {
	
	/**
	 * Gets the positions.
	 *
	 * @param plate the plate
	 * @param startDate the start date
	 * @param endDate the end date
	 * @return the positions
	 */
	public Collection<PositionJPA> getPositions(String plate, Date startDate, Date endDate );
	
	/**
	 * Gets the real time.
	 *
	 * @param plate the plate
	 * @return the real time
	 */
	public Collection<PositionJPA> getRealTime(String plate);

}
