/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingBusiness;

import java.util.Collection;
import javax.ejb.Local;

/**
 * The Interface IReceptionBusiness.
 */
@Local
public interface IReceptionBusiness {
	
	/**
	 * Receive position.
	 *
	 * @param position the position
	 * @return true, if successful
	 * @throws Exception the exception
	 */
	public boolean receivePosition(String position) throws Exception;
	
	/**
	 * Receive battery level.
	 *
	 * @param level the level
	 * @return true, if successful
	 * @throws Exception the exception
	 */
	public boolean receiveBatteryLevel(String level) throws Exception;
	
	/**
	 * Receive gsm signal.
	 *
	 * @param signal the signal
	 * @return true, if successful
	 * @throws Exception the exception
	 */
	public boolean receiveGsmSignal(String signal) throws Exception;
	
	/**
	 * Receive status.
	 *
	 * @param status the status
	 * @return true, if successful
	 * @throws Exception the exception
	 */
	public boolean receiveStatus(String status) throws Exception;
	
	/**
	 * Obtain configuration.
	 *
	 * @param deviceId the device id
	 * @return the collection
	 * @throws Exception the exception
	 */
	public Collection<String> obtainConfiguration(String deviceId) throws Exception;

}
