/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPersistence;

import java.io.Serializable;
import java.lang.Boolean;
import java.lang.Integer;
import java.lang.String;
import javax.persistence.*;

/**
 * The Class CommandJPA.
 */
@Entity
@Table(name = "jtracking.commands")
public class CommandJPA implements Serializable {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = -7406966687515357882L;

	/** The id. */
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Integer id;
	
	/** The sent. */
	@Column(nullable=false)
	private Boolean sent;
	
	/** The command txt. */
	@Column(nullable=false, length=180)
	private String commandTxt;
	
	/** The device. */
	@ManyToOne
	@JoinColumn(name="device_fk")
	private DeviceJPA device;
	
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public Integer getId() {
		return this.id;
	}

	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(Integer id) {
		this.id = id;
	}   
	
	/**
	 * Gets the sent.
	 *
	 * @return the sent
	 */
	public Boolean getSent() {
		return this.sent;
	}

	/**
	 * Sets the sent.
	 *
	 * @param sent the new sent
	 */
	public void setSent(Boolean sent) {
		this.sent = sent;
	}   
	
	/**
	 * Gets the command txt.
	 *
	 * @return the command txt
	 */
	public String getCommandTxt() {
		return this.commandTxt;
	}

	/**
	 * Sets the command txt.
	 *
	 * @param commandTxt the new command txt
	 */
	public void setCommandTxt(String commandTxt) {
		this.commandTxt = commandTxt;
	}
   
	/**
	 * Gets the device.
	 *
	 * @return the device
	 */
	public DeviceJPA getDevice() {
		return device;
	}

	/**
	 * Sets the device.
	 *
	 * @param device the new device
	 */
	public void setDevice(DeviceJPA device) {
		this.device = device;
	}

	/**
	 * Instantiates a new command JPA.
	 */
	public CommandJPA() {
		super();
	}   
}
