/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPersistence;

import java.io.Serializable;
import java.lang.String;
import java.util.Collection;
import java.util.Date;

import javax.persistence.*;


/**
 * The Class MissionJPA.
 */
@Entity
@Table(name = "jtracking.missions")
public class MissionJPA implements Serializable {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = -1741410525419915264L;

	/** The id. */
	@Id
	@Column(length = 20)
	private String id;

	/** The description. */
	@Column(nullable = false, length=50)
	private String description;

	/** The start date. */
	@Column(nullable = false)
	@Temporal(TemporalType.DATE)
	private Date startDate;

	/** The end date. */
	@Temporal(TemporalType.DATE)
	private Date endDate;

	/** The vehicles. */
	@OneToMany(mappedBy = "mission", cascade=CascadeType.REMOVE )
	private Collection<VehicleJPA> vehicles;

	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId() {
		return this.id;
	}

	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * Gets the description.
	 *
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Sets the description.
	 *
	 * @param description the new description
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * Sets the start date.
	 *
	 * @param startDate the new start date
	 */
	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}

	/**
	 * Gets the start date.
	 *
	 * @return the start date
	 */
	public Date getStartDate() {
		return this.startDate;
	}

	/**
	 * Sets the end date.
	 *
	 * @param endDate the new end date
	 */
	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}

	/**
	 * Gets the end date.
	 *
	 * @return the end date
	 */
	public Date getEndDate() {
		return this.endDate;
	}

	/**
	 * Gets the vehicles.
	 *
	 * @return the vehicles
	 */
	public Collection<VehicleJPA> getVehicles() {
		return vehicles;
	}

	/**
	 * Sets the vehicles.
	 *
	 * @param vehicles the new vehicles
	 */
	public void setVehicles(Collection<VehicleJPA> vehicles) {
		this.vehicles = vehicles;
	}

	/**
	 * Instantiates a new mission JPA.
	 */
	public MissionJPA() {
		super();
	}

}
