/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPersistence;

import java.io.Serializable;
import java.lang.String;
import javax.persistence.*;

/**
 * The Class PhoneLineJPA.
 */
@Entity
@Table(name = "jtracking.phonelines",
uniqueConstraints=@UniqueConstraint(columnNames={"device_fk"}))
public class PhoneLineJPA implements Serializable {


	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 339896820160912823L;

	/** The phone number. */
	@Id
	@Column(length=15)
	private String phoneNumber;
	
	/** The icc. */
	@Column(nullable=false, length=20, unique=true) 
	private String ICC;
	
	/** The pin. */
	@Column(nullable=false, length=8) 
	private String PIN;
	
	/** The puk. */
	@Column(nullable=false, length=8)
	private String PUK;
	
	/** The company. */
	@Column(nullable=false, length=20)
	private String company;
	
	/** The holder. */
	@Column(nullable=false, length=50)
	private String holder;
	
	/** The device. */
	@OneToOne
	@JoinColumn(name="device_fk")
	private DeviceJPA device;
	
	/**
	 * Gets the phone number.
	 *
	 * @return the phone number
	 */
	public String getPhoneNumber() {
		return phoneNumber;
	}

	/**
	 * Sets the phone number.
	 *
	 * @param phoneNumber the new phone number
	 */
	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}

	/**
	 * Gets the icc.
	 *
	 * @return the icc
	 */
	public String getICC() {
		return this.ICC;
	}

	/**
	 * Sets the icc.
	 *
	 * @param ICC the new icc
	 */
	public void setICC(String ICC) {
		this.ICC = ICC;
	}   
	
	/**
	 * Gets the pin.
	 *
	 * @return the pin
	 */
	public String getPIN() {
		return this.PIN;
	}

	/**
	 * Sets the pin.
	 *
	 * @param PIN the new pin
	 */
	public void setPIN(String PIN) {
		this.PIN = PIN;
	}   
	
	/**
	 * Gets the puk.
	 *
	 * @return the puk
	 */
	public String getPUK() {
		return this.PUK;
	}

	/**
	 * Sets the puk.
	 *
	 * @param PUK the new puk
	 */
	public void setPUK(String PUK) {
		this.PUK = PUK;
	}   
	
	/**
	 * Gets the company.
	 *
	 * @return the company
	 */
	public String getCompany() {
		return this.company;
	}

	/**
	 * Sets the company.
	 *
	 * @param company the new company
	 */
	public void setCompany(String company) {
		this.company = company;
	}   
	
	/**
	 * Gets the holder.
	 *
	 * @return the holder
	 */
	public String getHolder() {
		return this.holder;
	}

	/**
	 * Sets the holder.
	 *
	 * @param Holder the new holder
	 */
	public void setHolder(String Holder) {
		this.holder = Holder;
	}
	
	/**
	 * Gets the device.
	 *
	 * @return the device
	 */
	public DeviceJPA getDevice() {
		return device;
	}

	/**
	 * Sets the device.
	 *
	 * @param device the new device
	 */
	public void setDevice(DeviceJPA device) {
		this.device = device;
	}
	
	/**
	 * Instantiates a new phone line JPA.
	 */
	public PhoneLineJPA() {
		super();
	}   
	
}
