/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPersistence;

import java.io.Serializable;
import javax.persistence.*;
import javax.validation.constraints.Size;


/**
 * The Class UserJPA.
 */
@Entity
@Table(name = "jtracking.users")
@NamedQuery(name = "UserJPA.findAll", query = "SELECT u FROM UserJPA u")
public class UserJPA implements Serializable {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** The logname. */
	@Id
	@Size(max = 12)
	private String logname;

	/** The password. */
	@Column(nullable = false, length = 44)
	private String password;

	/** The name. */
	@Column(nullable = false, length = 30)
	private String name;

	/** The surname. */
	@Column(nullable = false, length = 40)
	private String surname;

	/** The email. */
	@Column(nullable = false, length = 320)
	private String email;

	/** The phone. */
	@Column(nullable = false, length = 19)
	private String phone;

	/** The role. */
	@OneToOne
	@JoinColumn(nullable = false, name = "role_fk")
	private RoleJPA role;

	/**
	 * Gets the logname.
	 *
	 * @return the logname
	 */
	public String getLogname() {
		return logname;
	}

	/**
	 * Sets the logname.
	 *
	 * @param logname the new logname
	 */
	public void setLogname(String logname) {
		this.logname = logname;
	}

	/**
	 * Gets the password.
	 *
	 * @return the password
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * Sets the password.
	 *
	 * @param password the new password
	 */
	public void setPassword(String password) {
		this.password = password;
	}

	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Gets the surname.
	 *
	 * @return the surname
	 */
	public String getSurname() {
		return surname;
	}

	/**
	 * Sets the surname.
	 *
	 * @param surname the new surname
	 */
	public void setSurname(String surname) {
		this.surname = surname;
	}

	/**
	 * Gets the email.
	 *
	 * @return the email
	 */
	public String getEmail() {
		return email;
	}

	/**
	 * Sets the email.
	 *
	 * @param email the new email
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * Gets the phone.
	 *
	 * @return the phone
	 */
	public String getPhone() {
		return phone;
	}

	/**
	 * Sets the phone.
	 *
	 * @param phone the new phone
	 */
	public void setPhone(String phone) {
		this.phone = phone;
	}

	/**
	 * Gets the role.
	 *
	 * @return the role
	 */
	public RoleJPA getRole() {
		return role;
	}

	/**
	 * Sets the role.
	 *
	 * @param role the new role
	 */
	public void setRole(RoleJPA role) {
		this.role = role;
	}

	/**
	 * Instantiates a new user JPA.
	 */
	public UserJPA() {
	}

}