/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPersistence;

import java.io.Serializable;
import java.lang.String;
import java.util.Collection;

import javax.persistence.*;



/**
 * The Class VehicleJPA.
 */
@Entity
@Table(name = "jtracking.vehicles",
uniqueConstraints=@UniqueConstraint(columnNames={"device_fk"}))
public class VehicleJPA implements Serializable {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = -7424908211840882549L;

	/** The plate. */
	@Id
	@Column(length=9)
	private String plate;
	
	/** The brand. */
	@Column(nullable=false, length=20)
	private String brand;
	
	/** The model. */
	@Column(nullable=false, length=30)
	private String model;
	
	/** The color. */
	@Column(length=20)
	private String color;
	
	/** The mission. */
	@ManyToOne
	@JoinColumn(name="mission_fk")
	private MissionJPA mission;
	
	
	/** The device. */
	@OneToOne
	@JoinColumn(name="device_fk")
	private DeviceJPA device;
	
	
	/** The positions. */
	@OneToMany(mappedBy="vehicle", cascade=CascadeType.REMOVE)
	private Collection<PositionJPA> positions;
		
	

	/**
	 * Gets the plate.
	 *
	 * @return the plate
	 */
	public String getPlate() {
		return plate;
	}

	/**
	 * Sets the plate.
	 *
	 * @param plate the new plate
	 */
	public void setPlate(String plate) {
		this.plate = plate;
	}

	/**
	 * Gets the brand.
	 *
	 * @return the brand
	 */
	public String getBrand() {
		return brand;
	}

	/**
	 * Sets the brand.
	 *
	 * @param brand the new brand
	 */
	public void setBrand(String brand) {
		this.brand = brand;
	}

	/**
	 * Gets the model.
	 *
	 * @return the model
	 */
	public String getModel() {
		return model;
	}

	/**
	 * Sets the model.
	 *
	 * @param model the new model
	 */
	public void setModel(String model) {
		this.model = model;
	}

	/**
	 * Gets the color.
	 *
	 * @return the color
	 */
	public String getColor() {
		return color;
	}

	/**
	 * Sets the color.
	 *
	 * @param color the new color
	 */
	public void setColor(String color) {
		this.color = color;
	}   


	/**
	 * Gets the mission.
	 *
	 * @return the mission
	 */
	public MissionJPA getMission() {
		return mission;
	}

	/**
	 * Sets the mission.
	 *
	 * @param mission the new mission
	 */
	public void setMission(MissionJPA mission) {
		this.mission = mission;
	}
	
	
	/**
	 * Gets the device.
	 *
	 * @return the device
	 */
	public DeviceJPA getDevice() {
		return device;
	}

	/**
	 * Sets the device.
	 *
	 * @param device the new device
	 */
	public void setDevice(DeviceJPA device) {
		this.device = device;
	}

	/**
	 * Gets the positions.
	 *
	 * @return the positions
	 */
	public Collection<PositionJPA> getPositions() {
		return positions;
	}

	/**
	 * Sets the positions.
	 *
	 * @param positions the new positions
	 */
	public void setPositions(Collection<PositionJPA> positions) {
		this.positions = positions;
	}
	

	/**
	 * Instantiates a new vehicle JPA.
	 */
	public VehicleJPA() {
		super();
	}

}
