/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import java.util.Date;

import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import jtrackingBusiness.IManagementBusiness;

/**
 * The Class AddMissionBean.
 */
@Named("mission")
@RequestScoped
public class AddMissionBean {

	/** The management. */
	@Inject
	private IManagementBusiness management;

	/** The id. */
	private String id;

	/** The description. */
	private String description;

	/** The start date. */
	private Date startDate;

	/** The end date. */
	private Date endDate;

	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public String getId() {
		return id;
	}

	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * Gets the description.
	 *
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Sets the description.
	 *
	 * @param description the new description
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * Gets the start date.
	 *
	 * @return the start date
	 */
	public Date getStartDate() {
		return startDate;
	}

	/**
	 * Sets the start date.
	 *
	 * @param startDate the new start date
	 */
	public void setStartDate(Date startDate) {

		this.startDate = startDate;
	}

	/**
	 * Gets the end date.
	 *
	 * @return the end date
	 */
	public Date getEndDate() {
		return endDate;
	}

	/**
	 * Sets the end date.
	 *
	 * @param endDate the new end date
	 */
	public void setEndDate(Date endDate) {

		this.endDate = endDate;
	}

	/**
	 * Instantiates a new adds the mission bean.
	 */
	public AddMissionBean() {

	}

	/**
	 * Adds the mission.
	 */
	public void addMission() {

		try {

			// endDat está asignada
			if (endDate != null) {
				// EndDate es correcta crear misión
				if (endDate.after(startDate)) {
					// Si se añade nueva misión
					if (management.addMission(id, description, startDate, endDate)) {
						StringBuilder message = new StringBuilder("Sucess: mission ").append(id).append(" ")
								.append(" added");
						FacesContext fc = FacesContext.getCurrentInstance();
						fc.addMessage(null, new FacesMessage(message.toString(), null));
					}
					// Si falla
					else {
						FacesContext fc = FacesContext.getCurrentInstance();
						fc.addMessage(null,
								new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error creating mission", null));
					}

				}

				// Si la endDate no es correcta
				else {

					FacesContext fc = FacesContext.getCurrentInstance();
					fc.addMessage(null,
							new FacesMessage(FacesMessage.SEVERITY_ERROR, "End date before start date", null));
				}

			}

			// Si endDate no está asignada
			else {
				// Si se añade una nueva misión
				if (management.addMission(id, description, startDate, endDate)) {

					StringBuilder message = new StringBuilder("Sucess: mission: ").append(id).append(" ")
							.append(" added");
					FacesContext fc = FacesContext.getCurrentInstance();
					fc.addMessage(null, new FacesMessage(message.toString(), null));

				}

				// Si falla
				else {
					FacesContext fc = FacesContext.getCurrentInstance();
					fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error creating mission", null));
				}

			}

		} catch (Exception e) {

			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while adding mission", id));

		}

	}

}
