/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import jtrackingBusiness.IManagementBusiness;

/**
 * The Class AddPhoneLineBean.
 */
@Named("phoneline")
@RequestScoped
public class AddPhoneLineBean {

	/** The management. */
	@Inject
	private IManagementBusiness management;

	/** The number. */
	private String number;

	/** The icc. */
	private String ICC;

	/** The pin. */
	private String PIN;

	/** The puk. */
	private String PUK;

	/** The company. */
	private String company;

	/** The holder. */
	private String holder;

	/**
	 * Gets the number.
	 *
	 * @return the number
	 */
	public String getNumber() {
		return number;
	}

	/**
	 * Sets the number.
	 *
	 * @param number the new number
	 */
	public void setNumber(String number) {
		this.number = number;
	}

	/**
	 * Gets the icc.
	 *
	 * @return the icc
	 */
	public String getICC() {
		return ICC;
	}

	/**
	 * Sets the icc.
	 *
	 * @param iCC the new icc
	 */
	public void setICC(String iCC) {
		ICC = iCC;
	}

	/**
	 * Gets the pin.
	 *
	 * @return the pin
	 */
	public String getPIN() {
		return PIN;
	}

	/**
	 * Sets the pin.
	 *
	 * @param pIN the new pin
	 */
	public void setPIN(String pIN) {
		PIN = pIN;
	}

	/**
	 * Gets the puk.
	 *
	 * @return the puk
	 */
	public String getPUK() {
		return PUK;
	}

	/**
	 * Sets the puk.
	 *
	 * @param pUK the new puk
	 */
	public void setPUK(String pUK) {
		PUK = pUK;
	}

	/**
	 * Gets the company.
	 *
	 * @return the company
	 */
	public String getCompany() {
		return company;
	}

	/**
	 * Sets the company.
	 *
	 * @param company the new company
	 */
	public void setCompany(String company) {
		this.company = company;
	}

	/**
	 * Gets the holder.
	 *
	 * @return the holder
	 */
	public String getHolder() {
		return holder;
	}

	/**
	 * Sets the holder.
	 *
	 * @param holder the new holder
	 */
	public void setHolder(String holder) {
		this.holder = holder;
	}
	

	/**
	 * Adds the phone line.
	 */
	public void addPhoneLine() {
		try {
			if (management.addPhoneLine(number, ICC, PIN, PUK, company, holder)) {
				StringBuilder message = new StringBuilder("Sucess \n phone line: ").append(number).append(" ")
						.append(" added");
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(message.toString(), null));
			} else {
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error creating phone line", null));
			}

		} catch (Exception e) {
			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error creating phone line", null));
		}
	}

	/**
	 * Instantiates a new adds the phone line bean.
	 */
	public AddPhoneLineBean() {

	}

}
