/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import java.nio.charset.StandardCharsets;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;

import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import jtrackingBusiness.IManagementBusiness;

/**
 * The Class AddUserBean.
 */
@Named("userbean")
@RequestScoped
public class AddUserBean {

	/** The management. */
	@Inject
	private IManagementBusiness management;

	/** The logname. */
	private String logname;

	/** The password. */
	private String password;

	/** The name. */
	private String name;

	/** The surname. */
	private String surname;

	/** The email. */
	private String email;

	/** The phone. */
	private String phone;

	/** The rolename. */
	private String rolename;

	/** The encoded password. */
	private String encodedPassword;

	/**
	 * Gets the logname.
	 *
	 * @return the logname
	 */
	public String getLogname() {
		return logname;
	}

	/**
	 * Sets the logname.
	 *
	 * @param logname the new logname
	 */
	public void setLogname(String logname) {
		this.logname = logname;
	}

	/**
	 * Gets the password.
	 *
	 * @return the password
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * Sets the password.
	 *
	 * @param password the new password
	 */
	public void setPassword(String password) {
		this.password = password;
	}

	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Gets the surname.
	 *
	 * @return the surname
	 */
	public String getSurname() {
		return surname;
	}

	/**
	 * Sets the surname.
	 *
	 * @param surname the new surname
	 */
	public void setSurname(String surname) {
		this.surname = surname;
	}

	/**
	 * Gets the email.
	 *
	 * @return the email
	 */
	public String getEmail() {
		return email;
	}

	/**
	 * Sets the email.
	 *
	 * @param email the new email
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * Gets the phone.
	 *
	 * @return the phone
	 */
	public String getPhone() {
		return phone;
	}

	/**
	 * Sets the phone.
	 *
	 * @param phone the new phone
	 */
	public void setPhone(String phone) {
		this.phone = phone;
	}

	/**
	 * Gets the rolename.
	 *
	 * @return the rolename
	 */
	public String getRolename() {
		return rolename;
	}

	/**
	 * Sets the rolename.
	 *
	 * @param rolename the new rolename
	 */
	public void setRolename(String rolename) {
		this.rolename = rolename;
	}

	/**
	 * Gets the encoded password.
	 *
	 * @return the encoded password
	 */
	public String getEncodedPassword() {
		return encodedPassword;
	}

	/**
	 * Sets the encoded password.
	 *
	 * @param encodedPassword the new encoded password
	 */
	public void setEncodedPassword(String encodedPassword) {
		this.encodedPassword = encodedPassword;
	}

	/**
	 * Adds the user.
	 */
	public void addUser() {

		MessageDigest digest;
		try {
			digest = MessageDigest.getInstance("SHA-256");
			byte[] hash = digest.digest(password.getBytes(StandardCharsets.UTF_8));
			encodedPassword = Base64.getEncoder().encodeToString(hash);
			if (management.addUser(logname, encodedPassword, name, surname, email, phone, rolename)) {
				StringBuilder message = new StringBuilder("Sucess \n User: ").append(name).append(" ").append(surname)
						.append(" added");
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(message.toString(), null));

			} else {
				StringBuilder message = new StringBuilder("Error adding user: ").append(logname);
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, message.toString(), null));

			}

		} catch (NoSuchAlgorithmException e) {

			e.printStackTrace();
		} catch (Exception e) {

			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while adding user", logname));

		}

	}

}
