/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import jtrackingBusiness.IManagementBusiness;

/**
 * The Class AddVehicleBean.
 */
@Named("vehicle")
@RequestScoped
public class AddVehicleBean {

	/** The management. */
	@Inject
	private IManagementBusiness management;

	/** The plate. */
	private String plate;

	/** The brand. */
	private String brand;

	/** The model. */
	private String model;

	/** The color. */
	private String color;

	/** The mission. */
	private String mission;

	/**
	 * Instantiates a new adds the vehicle bean.
	 */
	public AddVehicleBean() {

	}

	/**
	 * Gets the plate.
	 *
	 * @return the plate
	 */
	public String getPlate() {
		return plate;
	}

	/**
	 * Sets the plate.
	 *
	 * @param plate the new plate
	 */
	public void setPlate(String plate) {
		this.plate = plate;
	}

	/**
	 * Gets the brand.
	 *
	 * @return the brand
	 */
	public String getBrand() {
		return brand;
	}

	/**
	 * Sets the brand.
	 *
	 * @param brand the new brand
	 */
	public void setBrand(String brand) {
		this.brand = brand;
	}

	/**
	 * Gets the model.
	 *
	 * @return the model
	 */
	public String getModel() {
		return model;
	}

	/**
	 * Sets the model.
	 *
	 * @param model the new model
	 */
	public void setModel(String model) {
		this.model = model;
	}

	/**
	 * Gets the color.
	 *
	 * @return the color
	 */
	public String getColor() {
		return color;
	}

	/**
	 * Sets the color.
	 *
	 * @param color the new color
	 */
	public void setColor(String color) {
		this.color = color;
	}

	/**
	 * Gets the mission.
	 *
	 * @return the mission
	 */
	public String getMission() {
		return mission;
	}

	/**
	 * Sets the mission.
	 *
	 * @param mission the new mission
	 */
	public void setMission(String mission) {
		this.mission = mission;
	}

	/**
	 * Adds the vehicle.
	 */
	public void addVehicle() {

		try {
			if (management.addVehicle(plate, brand, model, color)) {
				StringBuilder message = new StringBuilder("Sucess: \n vehicle ").append(plate).append(" ")
						.append(" added");
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(message.toString(), null));
			} else {
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error creating vehicle", null));
			}
		} catch (Exception e) {

			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while adding vehicle", plate));

		}

	}

}
