/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import java.nio.charset.StandardCharsets;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;

import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jtrackingBusiness.IManagementBusiness;

/**
 * The Class ChangePasswordBean.
 */
@Named("changepassword")
@RequestScoped
public class ChangePasswordBean {

	/** The management. */
	@Inject
	private IManagementBusiness management;

	/** The old password. */
	private String oldPassword;

	/** The new password. */
	private String newPassword;

	/** The old encoded password. */
	private String oldEncodedPassword;

	/** The new encoded password. */
	private String newEncodedPassword;

	/**
	 * Gets the old password.
	 *
	 * @return the old password
	 */
	public String getOldPassword() {
		return oldPassword;
	}

	/**
	 * Sets the old password.
	 *
	 * @param oldPassword the new old password
	 */
	public void setOldPassword(String oldPassword) {
		this.oldPassword = oldPassword;
	}

	/**
	 * Gets the new password.
	 *
	 * @return the new password
	 */
	public String getNewPassword() {
		return newPassword;
	}

	/**
	 * Sets the new password.
	 *
	 * @param newPassword the new new password
	 */
	public void setNewPassword(String newPassword) {
		this.newPassword = newPassword;
	}

	/**
	 * Gets the old encoded password.
	 *
	 * @return the old encoded password
	 */
	public String getOldEncodedPassword() {
		return oldEncodedPassword;
	}

	/**
	 * Sets the old encoded password.
	 *
	 * @param oldEncodedPassword the new old encoded password
	 */
	public void setOldEncodedPassword(String oldEncodedPassword) {
		this.oldEncodedPassword = oldEncodedPassword;
	}

	/**
	 * Gets the new encoded password.
	 *
	 * @return the new encoded password
	 */
	public String getNewEncodedPassword() {
		return newEncodedPassword;
	}

	/**
	 * Sets the new encoded password.
	 *
	 * @param newEncodedPassword the new new encoded password
	 */
	public void setNewEncodedPassword(String newEncodedPassword) {
		this.newEncodedPassword = newEncodedPassword;
	}

	/**
	 * Instantiates a new change password bean.
	 */
	public ChangePasswordBean() {

	}

	/**
	 * Change password.
	 *
	 * @return the string
	 */
	public String changePassword() {

		MessageDigest digest;
		try {
			digest = MessageDigest.getInstance("SHA-256");

			byte[] hash = digest.digest(oldPassword.getBytes(StandardCharsets.UTF_8));
			oldEncodedPassword = Base64.getEncoder().encodeToString(hash);

			byte[] hash1 = digest.digest(newPassword.getBytes(StandardCharsets.UTF_8));
			newEncodedPassword = Base64.getEncoder().encodeToString(hash1);

			HttpServletRequest request = (HttpServletRequest) FacesContext.getCurrentInstance().getExternalContext()
					.getRequest();
			String logname = request.getRemoteUser();

			if (management.changePassword(logname, oldEncodedPassword, newEncodedPassword)) {
				StringBuilder message = new StringBuilder("Sucess \n");
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(message.toString(), null));

			} else {
				StringBuilder message = new StringBuilder("Security breach");
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, message.toString(), null));
				Thread.sleep(3000);
				((HttpSession) FacesContext.getCurrentInstance().getExternalContext().getSession(true)).invalidate();
				return "/home";

			}

		} catch (NoSuchAlgorithmException e) {

			e.printStackTrace();
		} catch (Exception e) {

			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while changing password", null));
			

		}

		return null;

	}
}
