/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import jtrackingBusiness.ICommandBusiness;
import jtrackingPersistence.DeviceJPA;

/**
 * The Class CheckStatusBean.
 */
@Named("checkstatus")
@RequestScoped
public class CheckStatusBean implements Serializable{

/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 879519691022486860L;

/** The commander. */
@Inject
private ICommandBusiness commander;

/** The devices collection. */
private Collection<DeviceJPA> devicesCollection = new ArrayList<>();

/**
 * Gets the devices collection.
 *
 * @return the devices collection
 */
public Collection<DeviceJPA> getDevicesCollection() {
	return devicesCollection;
}

/**
 * Sets the devices collection.
 *
 * @param devicesCollection the new devices collection
 */
public void setDevicesCollection(Collection<DeviceJPA> devicesCollection) {
	this.devicesCollection = devicesCollection;
}

/**
 * Check status.
 *
 * @return the string
 */
public String checkStatus() {
	try {
		devicesCollection.addAll(commander.checkStatus());
		//FacesContext.getCurrentInstance().getExternalContext().redirect("checkstatus.xhtml");
		
	} catch (Exception e) {
		FacesContext fc = FacesContext.getCurrentInstance();
		fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while getting devices status", null));
		FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);
	}
	return "checkstatus.xhtml";

}
	
	/**
	 * Instantiates a new check status bean.
	 */
	public CheckStatusBean() {
		
	}

}
