/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import jtrackingBusiness.IManagementBusiness;
import jtrackingPersistence.PhoneLineJPA;

/**
 * The Class ListPhoneLinesBean.
 */
@Named("phonelines")
@SessionScoped
public class ListPhoneLinesBean implements Serializable {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = -1795791351976476365L;

	/** The management. */
	@Inject
	private IManagementBusiness management;

	/** The phone lines collection. */
	private Collection<PhoneLineJPA> phoneLinesCollection = new ArrayList<>();

	/** The number. */
	private String number;

	/**
	 * Gets the phone lines collection.
	 *
	 * @return the phone lines collection
	 */
	public Collection<PhoneLineJPA> getPhoneLinesCollection() {
		return phoneLinesCollection;
	}

	/**
	 * Sets the phone lines collection.
	 *
	 * @param phoneLinesCollection the new phone lines collection
	 */
	public void setPhoneLinesCollection(Collection<PhoneLineJPA> phoneLinesCollection) {
		this.phoneLinesCollection = phoneLinesCollection;
	}

	/**
	 * Gets the number.
	 *
	 * @return the number
	 */
	public String getNumber() {
		return number;
	}

	/**
	 * Sets the number.
	 *
	 * @param number the new number
	 */
	public void setNumber(String number) {
		this.number = number;
	}

	/**
	 * Gets the phone lines list.
	 *
	 * @return the phone lines list
	 */
	public void getPhoneLinesList() {
		try {
			phoneLinesCollection.clear();
			phoneLinesCollection.addAll(management.getPhoneLines());
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			FacesContext.getCurrentInstance().getExternalContext().redirect("phonelines.xhtml");
		} catch (IOException e) {

			e.printStackTrace();
		}
	}
	
	/**
	 * Delete phone line.
	 */
	public void deletePhoneLine() {
		
		try {
			if (management.deletePhoneLine(number)) {
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage("Sucess", "Phone line deleted"));
				FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);
			} else {

				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null,
						new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while deleting phoneline", null));
				FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);

			}
		} catch (Exception e) {

			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while deleting phoneline", null));

		}

		getPhoneLinesList();
	}
	
	
	/**
	 * Instantiates a new list phone lines bean.
	 */
	public ListPhoneLinesBean() {

	}

}
