/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;

import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.primefaces.event.RowEditEvent;

import jtrackingBusiness.IManagementBusiness;
import jtrackingPersistence.UserJPA;

/**
 * The Class ListUsersBean.
 */
@Named("users")
@SessionScoped
public class ListUsersBean implements Serializable {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 2710728442123008996L;

	/** The management. */
	@Inject
	private IManagementBusiness management;

	/** The users collection. */
	private Collection<UserJPA> usersCollection = new ArrayList<>();

	/** The user id. */
	private String userId;

	/**
	 * Gets the users collection.
	 *
	 * @return the users collection
	 */
	public Collection<UserJPA> getUsersCollection() {
		return usersCollection;
	}

	/**
	 * Sets the users collection.
	 *
	 * @param usersCollection the new users collection
	 */
	public void setUsersCollection(Collection<UserJPA> usersCollection) {
		this.usersCollection = usersCollection;
	}

	/**
	 * Sets the users col.
	 *
	 * @param usersCollection the new users col
	 */
	public void setUsersCol(Collection<UserJPA> usersCollection) {
		this.usersCollection = usersCollection;
	}

	/**
	 * Gets the user id.
	 *
	 * @return the user id
	 */
	public String getUserId() {
		return userId;
	}

	/**
	 * Sets the user id.
	 *
	 * @param userId the new user id
	 */
	public void setUserId(String userId) {
		this.userId = userId;
	}

	/**
	 * Gets the users list.
	 *
	 * @return the users list
	 */
	public void getUsersList() {

		try {
			usersCollection.clear();
			usersCollection.addAll(management.getUsers());
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			FacesContext.getCurrentInstance().getExternalContext().redirect("users.xhtml");
		} catch (IOException e) {

			e.printStackTrace();
		}
	}

	/**
	 * Delete user.
	 */
	public void deleteUser() {
		try {
			if (userId.equals("admin")) {

				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null,
						new FacesMessage(FacesMessage.SEVERITY_ERROR, "Imposible to delete " + userId, null));

			} else {
				if (management.deleteUser(userId)) {
					FacesContext fc = FacesContext.getCurrentInstance();
					fc.addMessage(null, new FacesMessage("Sucess"));
					FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);
					getUsersList();
				} else {
					FacesContext fc = FacesContext.getCurrentInstance();
					fc.addMessage(null,
							new FacesMessage(FacesMessage.SEVERITY_ERROR, "Imposible to delete " + userId, null));
					FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);

				}

			}

		} catch (Exception e) {
			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Imposible to delete " + userId, null));

		}

	}

	/**
	 * On edit.
	 *
	 * @param event the event
	 * @return the string
	 */
	public String onEdit(RowEditEvent event) {

		UserJPA user = (UserJPA) event.getObject();
		try {
			if (user.getLogname().equals("admin")) {

				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR,
						"Imposible to update " + user.getLogname(), null));

			} else {
				if (management.updateUser(user.getLogname(), user.getName(), user.getSurname(), user.getEmail(),
						user.getPhone(), user.getRole().getRole())) {
					FacesContext fc = FacesContext.getCurrentInstance();
					fc.addMessage(null, new FacesMessage("Sucess"));
				}
				else
				{

					FacesContext fc = FacesContext.getCurrentInstance();
					fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while updating", null));
				}
			}

		} catch (Exception e) {

			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while updating", null));
		}
		return "users.xhtml";
	}

	/**
	 * On cancel.
	 *
	 * @param event the event
	 * @return the string
	 */
	public String onCancel(RowEditEvent event) {

		FacesContext fc = FacesContext.getCurrentInstance();
		fc.addMessage(null, new FacesMessage("Action cancelled by user"));
		return null;
	}
}
