/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import jtrackingBusiness.IManagementBusiness;
import jtrackingPersistence.VehicleJPA;

/**
 * The Class ListVehiclesBean.
 */
@Named("vehicles")
@SessionScoped
public class ListVehiclesBean implements Serializable {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = -5115094828867188765L;

	/** The management. */
	@Inject
	private IManagementBusiness management;

	/** The vehicles. */
	private Collection<VehicleJPA> vehicles = new ArrayList<>();

	/** The plate. */
	private String plate;

	/**
	 * Gets the plate.
	 *
	 * @return the plate
	 */
	public String getPlate() {
		return plate;
	}

	/**
	 * Sets the plate.
	 *
	 * @param plate the new plate
	 */
	public void setPlate(String plate) {
		this.plate = plate;
	}

	/**
	 * Instantiates a new list vehicles bean.
	 */
	public ListVehiclesBean() {
		super();
	}

	/**
	 * Gets the vehicles.
	 *
	 * @return the vehicles
	 */
	public Collection<VehicleJPA> getVehicles() {
		return vehicles;
	}

	/**
	 * Sets the vehicles.
	 *
	 * @param vehicles the new vehicles
	 */
	public void setVehicles(Collection<VehicleJPA> vehicles) {
		this.vehicles = vehicles;
	}

	/**
	 * Gets the vehicles list.
	 *
	 * @return the vehicles list
	 */
	public void getVehiclesList() {
		try {
			vehicles.clear();
			vehicles.addAll(management.getVehicles());
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			FacesContext.getCurrentInstance().getExternalContext().redirect("vehicles.xhtml");
		} catch (IOException e) {

			e.printStackTrace();
		}
	}


	/**
	 * Delete vehicle.
	 */
	public void deleteVehicle() {
		try {
			if (management.deleteVehicle(plate)) {
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage("Sucess", "Vehicle deleted"));
				FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);
			} else {

				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null,
						new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while deleting vehicle", null));
				FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);

			}
		} catch (Exception e) {

			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while deleting vehicle", null));

		}

		getVehiclesList();
	}

}
