/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

import javax.annotation.PostConstruct;
import javax.enterprise.context.SessionScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.primefaces.component.export.PDFOptions;

import com.lowagie.text.BadElementException;
import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.PageSize;

import jtrackingBusiness.IManagementBusiness;
import jtrackingBusiness.IMappingBusiness;
import jtrackingPersistence.PositionJPA;
import jtrackingPersistence.VehicleJPA;

/**
 * The Class PositionsBean.
 */
@Named("positions")
@SessionScoped
public class PositionsBean implements Serializable{
	

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 2123164684269763885L;

	/** The mapper. */
	@Inject
	private IMappingBusiness mapper;
	
	/** The manager. */
	@Inject
	private IManagementBusiness manager;
	
	/** The latitud. */
	private float latitud;
	
	/** The longitud. */
	private float longitud;
	
	/** The plate. */
	private String plate;
	
	/** The start date. */
	private Date startDate;
	
	/** The end date. */
	private Date endDate;
	
	/** The pdf opt. */
	private PDFOptions pdfOpt;
	
	/** The positions. */
	private Collection<PositionJPA> positions;
	
	/** The positions table. */
	private Collection<PositionJPA> positionsTable;
	
	/** The vehicles. */
	private Collection<VehicleJPA> vehicles;
	
	/** The vehicles id. */
	private Collection<String> vehiclesId;
	
	

	/**
	 * Gets the latitud.
	 *
	 * @return the latitud
	 */
	public float getLatitud() {
		return latitud;
	}


	/**
	 * Sets the latitud.
	 *
	 * @param latitud the new latitud
	 */
	public void setLatitud(float latitud) {
		this.latitud = latitud;
	}


	/**
	 * Gets the longitud.
	 *
	 * @return the longitud
	 */
	public float getLongitud() {
		return longitud;
	}


	/**
	 * Sets the longitud.
	 *
	 * @param longitud the new longitud
	 */
	public void setLongitud(float longitud) {
		this.longitud = longitud;
	}


	/**
	 * Gets the positions.
	 *
	 * @return the positions
	 */
	public Collection<PositionJPA> getPositions() {
		return positions;
	}


	/**
	 * Sets the positions.
	 *
	 * @param positions the new positions
	 */
	public void setPositions(Collection<PositionJPA> positions) {
		this.positions = positions;
	}

	
	
	/**
	 * Gets the positions table.
	 *
	 * @return the positions table
	 */
	

	public Collection<PositionJPA> getPositionsTable() {
		return positionsTable;
	}


	/**
	 * Sets the positions table.
	 *
	 * @param positionsTable the new positions table
	 */
	public void setPositionsTable(Collection<PositionJPA> positionsTable) {
		this.positionsTable = positionsTable;
	}


	/**
	 * Gets the vehicles.
	 *
	 * @return the vehicles
	 */
	public Collection<VehicleJPA> getVehicles() {
		return vehicles;
	}


	/**
	 * Sets the vehicles.
	 *
	 * @param vehicles the new vehicles
	 */
	public void setVehicles(Collection<VehicleJPA> vehicles) {
		this.vehicles = vehicles;
	}


	/**
	 * Gets the plate.
	 *
	 * @return the plate
	 */
	public String getPlate() {
		return plate;
	}


	/**
	 * Sets the plate.
	 *
	 * @param plate the new plate
	 */
	public void setPlate(String plate) {
		this.plate = plate;
	}


	/**
	 * Gets the vehicles id.
	 *
	 * @return the vehicles id
	 */
	public Collection<String> getVehiclesId() {
		return vehiclesId;
	}


	/**
	 * Sets the vehicles id.
	 *
	 * @param vehiclesId the new vehicles id
	 */
	public void setVehiclesId(Collection<String> vehiclesId) {
		this.vehiclesId = vehiclesId;
	}


	/**
	 * Gets the start date.
	 *
	 * @return the start date
	 */
	public Date getStartDate() {
		return startDate;
	}


	/**
	 * Sets the start date.
	 *
	 * @param startDate the new start date
	 */
	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}


	/**
	 * Gets the end date.
	 *
	 * @return the end date
	 */
	public Date getEndDate() {
		return endDate;
	}


	/**
	 * Sets the end date.
	 *
	 * @param endDate the new end date
	 */
	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}


	/**
	 * Retrieve positions.
	 */
	public void retrievePositions()
	{
		try {
			positions.clear();
			positions.addAll(mapper.getPositions(plate, startDate, endDate));
			
		} catch (Exception e) {
			
		}
	}
	
	/**
	 * Retrieve positions table.
	 */
	public void retrievePositionsTable()
	{
		try {
			positionsTable.clear();
			positionsTable.addAll((mapper.getPositions(plate, startDate, endDate)));
		} catch (Exception e) {
			
		}
	}
	
	/**
	 * Gets the real time.
	 *
	 * @return the real time
	 */
	public void getRealTime()
	{
		try {
			positions.clear();
			positions.addAll(mapper.getRealTime(plate));
			
		} catch (Exception e) {
			
		}
	}
	
	/**
	 * Sets the values.
	 *
	 * @return the string
	 */
	public String setValues() {
		try {
		vehicles.clear();
		vehiclesId.clear();
		vehicles.addAll(manager.getVehicles());
		for(VehicleJPA vehi: vehicles)
		{
			vehiclesId.add(vehi.getPlate());
		}
			
		} catch (Exception e) {
		
		}
		return "mapping.xhtml?faces-redirect=true";
	}
	
	/**
	 * Inits the.
	 */
	@PostConstruct
	public void init() {
		
		positions = new ArrayList<>();
		positionsTable = new ArrayList<>();
		vehicles = new ArrayList<>();
		vehiclesId = new ArrayList<>();
		pdfOpt = new PDFOptions();
        pdfOpt.setCellFontSize("10");
    }
	
	/**
	 * Pre process.
	 *
	 * @param doc the doc
	 * @throws IOException Signals that an I/O exception has occurred.
	 * @throws BadElementException the bad element exception
	 * @throws DocumentException the document exception
	 */
	public void preProcess(Object doc) throws IOException, BadElementException, DocumentException{
		Document pdf = (Document) doc;
	      pdf.setPageSize(PageSize.A4.rotate());
	      pdf.open();
	}
	
	/**
	 * Instantiates a new positions bean.
	 */
	public PositionsBean() {
		
	}

}
