/*
 * Proyecto J-Tracking
 * Trabajo de Fin de Grado UOC 2017
 * Alumno: Rafael Fernández Lorenzo
 * Consultor: Vicenç Font Sagrista
 */
package jtrackingPresentation;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;

import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import jtrackingBusiness.IManagementBusiness;
import jtrackingPersistence.DeviceJPA;
import jtrackingPersistence.MissionJPA;
import jtrackingPersistence.VehicleJPA;

/**
 * The Class UpdateVehicleBean.
 */
@Named("updatevehicle")
@SessionScoped
public class UpdateVehicleBean implements Serializable {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 7427275019249783336L;

	/** The management. */
	@Inject
	private IManagementBusiness management;

	/** The list vehicles bean. */
	@Inject
	private ListVehiclesBean listVehiclesBean;

	/** The vehicle. */
	private VehicleJPA vehicle;

	/** The plate. */
	private String plate;

	/** The brand. */
	private String brand;

	/** The model. */
	private String model;

	/** The color. */
	private String color;

	/** The mission id. */
	private String missionId;

	/** The device ID. */
	private Integer deviceID;

	/** The missions collection. */
	private Collection<MissionJPA> missionsCollection = new ArrayList<>();

	/** The missions id collection. */
	private Collection<String> missionsIdCollection = new ArrayList<>();

	/** The devices collection. */
	private Collection<DeviceJPA> devicesCollection = new ArrayList<>();

	/** The devices id collection. */
	private Collection<Integer> devicesIdCollection = new ArrayList<>();

	/**
	 * Gets the vehicle.
	 *
	 * @return the vehicle
	 */
	public VehicleJPA getVehicle() {
		return vehicle;
	}

	/**
	 * Sets the vehicle.
	 *
	 * @param vehicle the new vehicle
	 */
	public void setVehicle(VehicleJPA vehicle) {
		this.vehicle = vehicle;
	}

	/**
	 * Gets the plate.
	 *
	 * @return the plate
	 */
	public String getPlate() {
		return plate;
	}

	/**
	 * Sets the plate.
	 *
	 * @param plate the new plate
	 */
	public void setPlate(String plate) {
		this.plate = plate;
	}

	/**
	 * Gets the brand.
	 *
	 * @return the brand
	 */
	public String getBrand() {
		return brand;
	}

	/**
	 * Sets the brand.
	 *
	 * @param brand the new brand
	 */
	public void setBrand(String brand) {
		this.brand = brand;
	}

	/**
	 * Gets the model.
	 *
	 * @return the model
	 */
	public String getModel() {
		return model;
	}

	/**
	 * Sets the model.
	 *
	 * @param model the new model
	 */
	public void setModel(String model) {
		this.model = model;
	}

	/**
	 * Gets the color.
	 *
	 * @return the color
	 */
	public String getColor() {
		return color;
	}

	/**
	 * Sets the color.
	 *
	 * @param color the new color
	 */
	public void setColor(String color) {
		this.color = color;
	}

	/**
	 * Gets the mission id.
	 *
	 * @return the mission id
	 */
	public String getMissionId() {
		return missionId;
	}

	/**
	 * Sets the mission id.
	 *
	 * @param missionId the new mission id
	 */
	public void setMissionId(String missionId) {
		this.missionId = missionId;
	}

	/**
	 * Gets the device ID.
	 *
	 * @return the device ID
	 */
	public Integer getDeviceID() {
		return deviceID;
	}

	/**
	 * Sets the device ID.
	 *
	 * @param deviceID the new device ID
	 */
	public void setDeviceID(Integer deviceID) {
		this.deviceID = deviceID;
	}

	/**
	 * Gets the missions collection.
	 *
	 * @return the missions collection
	 */
	public Collection<MissionJPA> getMissionsCollection() {
		return missionsCollection;
	}

	/**
	 * Sets the missions collection.
	 *
	 * @param missionsCollection the new missions collection
	 */
	public void setMissionsCollection(Collection<MissionJPA> missionsCollection) {
		this.missionsCollection = missionsCollection;
	}

	/**
	 * Gets the missions id collection.
	 *
	 * @return the missions id collection
	 */
	public Collection<String> getMissionsIdCollection() {
		return missionsIdCollection;
	}

	/**
	 * Sets the missions id collection.
	 *
	 * @param missionsIdCollection the new missions id collection
	 */
	public void setMissionsIdCollection(Collection<String> missionsIdCollection) {
		this.missionsIdCollection = missionsIdCollection;
	}

	/**
	 * Gets the devices collection.
	 *
	 * @return the devices collection
	 */
	public Collection<DeviceJPA> getDevicesCollection() {
		return devicesCollection;
	}

	/**
	 * Sets the devices collection.
	 *
	 * @param devicesCollection the new devices collection
	 */
	public void setDevicesCollection(Collection<DeviceJPA> devicesCollection) {
		this.devicesCollection = devicesCollection;
	}

	/**
	 * Gets the devices id collection.
	 *
	 * @return the devices id collection
	 */
	public Collection<Integer> getDevicesIdCollection() {
		return devicesIdCollection;
	}

	/**
	 * Sets the devices id collection.
	 *
	 * @param devicesIdCollection the new devices id collection
	 */
	public void setDevicesIdCollection(Collection<Integer> devicesIdCollection) {
		this.devicesIdCollection = devicesIdCollection;
	}

	/**
	 * Show vehicle data.
	 *
	 * @return the string
	 */
	public String showVehicleData() {

		this.plate = vehicle.getPlate();
		this.brand = vehicle.getBrand();
		this.model = vehicle.getModel();
		this.color = vehicle.getColor();
		this.missionId = "";
		this.deviceID = null;
		if (vehicle.getMission() != null) {
			this.missionId = vehicle.getMission().getId();
		}

		if (vehicle.getDevice() != null) {
			this.deviceID = vehicle.getDevice().getId();
		}

		try {
			missionsCollection.clear();
			missionsIdCollection.clear();
			devicesCollection.clear();
			devicesIdCollection.clear();
			missionsCollection.addAll(management.getMissions());
			devicesCollection.addAll(management.getDevices());
			for (MissionJPA miss : missionsCollection) {
				missionsIdCollection.add(miss.getId());
			}
			for (DeviceJPA dev : devicesCollection) {
				if(dev.getVehicle() == null)
				{
					devicesIdCollection.add(dev.getId());
				}
				
			}
			
		} catch (Exception e) {

			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error while getting vehicle data", null));
		}
		return "updatevehicle.xhtml?faces-redirect=true";
	}

	/**
	 * Update vehicle.
	 */
	public void updateVehicle() {

		try {

			if (management.updateVehicle(plate, brand, model, color, missionId, deviceID)) {
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage("Sucess", "Vehicle updated"));
				FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);

			} else {
				FacesContext fc = FacesContext.getCurrentInstance();
				fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error to update ", null));
				FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);
			}
		} catch (Exception e) {
			FacesContext fc = FacesContext.getCurrentInstance();
			fc.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error to update ", null));
			FacesContext.getCurrentInstance().getExternalContext().getFlash().setKeepMessages(true);
		}
		listVehiclesBean.getVehiclesList();

	}

}
